Part: Offset 2D

From FreeCAD Documentation
Revision as of 08:49, 1 April 2017 by Renatorivo (talk | contribs) (Created page with "==Uso== # Selezionare un oggetto 2D # Invocare il comando Offset 2D di Parte. # Impostare l'offset nel Pannello delle attività, e confermare nella finestra di dialogo.")

Offset 2D

Posizione nel menu
Parte → Offset 2D
Ambiente
Parte
Avvio veloce
Nessuno
Introdotto nella versione
-
Vedere anche
Part Offset 3D, Part Spessore, Draft Offset

Descrizione

Offset 2D di Parte costruisce un contorno, parallelo al contorno originale, ad una data distanza da esso. Oppure ingrandisce o restringe una faccia piana, in modo simile.

La faccia del contorno deve essere planare. In un oggetto ci possono essere più contorni, non necessariamente complanari.

Uso

  1. Selezionare un oggetto 2D
  2. Invocare il comando Offset 2D di Parte.
  3. Impostare l'offset nel Pannello delle attività, e confermare nella finestra di dialogo.

A 2D Offset parametric object is created. Original objects are switched to wireframe display mode.

Properties

Offset

  • DatiSource: Link to original shape
  • DatiValue The distance to enlarge the wire/face by. If negative, the wire/face is shrunk instead.
  • DatiMode ("Pipe" or "Skin"): sets how non-closed wires are processed. If "Pipe", the wire is outlined as if it was an extremely thin closed contour. If "Skin", an open wire is created.

  • DatiJoin ("Arc", "Tangent", "Intersection"): sets the behavior around kinks. If "Arc", offset segments are connected with an arc of circle, centered at the vertex. "Tangent" is unsupported on OCC7.0.0. "Intersection": offset segments are extended till they intersect.

  • DatiIntersection ("false", "true"): sets if multiple wires are treated collectively or independently. If "false", wires are offset independently, intersections between resulting wires are ignored. If "true", the wires are offset in collective manner.

Only wires within a compound are coupled. For example, if the structure is like compound(wire1, wire2, compound(wire3, wire4)), wire1 and wire2 will be treated collectively, but independently from wire3 and wire4. Likewise, wire3 and wire4 are treated collectively, but independently of wire1+wire2.

Also, in collective mode, directions of wires are important, and influence direction of offset. This is in tight relationship with how holes in faces are treated.

Wires being treated collectively must be coplanar. Wires being offset independently don't have to be coplanar.

  • DatiFill ("false", "true"): if "true", the space between original wire/face and the offset is filled with a face.

Known issues

  • Using the tool can crash FreeCAD (see next point). On Windows, these crashes are converted to exceptions and don't generally cause FreeCAD to close; on other OS'es it is not the case. So, it is advised to save project before attempting to use the tool.
  • Enlarging faces with circular holes by an amount large enough to cause holes to close up, a crash occurs (OCC 7.0.0). The problem seems to be specific to circles; other shapes seem to close out properly.
  • when offsetting circles that have non-zero Placement, the result is placed wrongly. (OCC 7.0.0)
  • when offsetting circles, sometimes they are offset in unexpected direction (e.g. inward instead of outward). (OCC 7.0.0)
  • Fill="true" doesn't work when collectively offsetting open wires in "Skin" mode
  • "Tangent" join mode doesn't work (OCC 7.0.0)
  • Offsetting wires made of single line segment is not supported (because line segment doesn't define a plane). Single line segments cannot participate in collective offset either.

Scripting

The tool can by used in macros and from the python console by using the following function:

f = App.ActiveDocument.addObject("Part::Offset2D", "Offset2D")
f.Source =  #some object
f.Value = 10.0

2D offset is also available as a method of Part.Shape. Example:

import Part
circle = Part.Circle().toShape()
enlarged_circle = circle.makeOffset2D(10.0)
Part.show(circle)
Part.show(enlarged_circle)
# makeOffset2D(offset, join = 0, fill = False, openResult = false, intersection = false)
# 
# * offset: distance to expand the shape by. 
# 
# * join: method of offsetting non-tangent joints. 0 = arcs, 1 = tangent, 2 =
# intersection
# 
# * fill: if true, the output is a face filling the space covered by offset. If
# false, the output is a wire/face.
# 
# * openResult: True for "Skin" mode; False for Pipe mode. 
# 
# * intersection: collective offset
# 
# Returns: result of offsetting (wire or face or compound of those). Compounding
# structure follows that of source shape.

Version

The tool was introduced in FreeCAD v0.17.8350. Most of non-default modes will only work with OCC 7.0.0 or later.